<?php
/**
 * URL-Rewrite Addon
 * @author wolfgang[at]busch-dettum[dot]de Wolfgang Busch
 * @package redaxo5
 * @version August 2017
 */
#
class fe_output {
#
function output() {
   #   Frontend-Ausgabe des Artikels.
   #   Die Extension gibt den tatsaechlich gewuenschten Artikel aus.
   #   Wird dieser nicht gefunden oder ist offline, wird stattdessen
   #   der NotFound-Artikel ausgegeben.
   #
   # --- anzuzeigender Artikel
   #   Aus $_SERVER["REQUEST_URI"] wird der auszugebende Artikel
   #   ermittelt. Ggf. alternativ der Notfound-Artikel.
   $article=self::get_article_from_uri();
   $art_id  =$article->getId();
   $clang_id=$article->getValue("clang_id");
   $temp_id =$article->getValue("template_id");
   #
   # --- neuen Artikel-Inhalt mit obigen Parametern definieren
   $content=new rex_article_content;
   $content->setArticleId($art_id);
   $content->setTemplateID($temp_id);
   $content->setCLang($clang_id);
   #
   # --- Properties article_id und clang_id setzen
   my_article::setProperty("article_id",$art_id);
   my_clang::setProperty("clang_id",$clang_id);
   #
   # --- neuen Artikel-Inhalt ausgeben
   rex_response::sendPage($content->getArticleTemplate());
   }
function get_article_from_uri() {
   #   Rueckgabe des Artikels, der im Frontend angezeigt wird. Falls
   #   der Artikel nicht bestimmt werden kann oder offline ist, wird
   #   stattdessen der Notfound-Artikel zurueck gegeben.
   #   Neben dem Wunsch-URL werden zusaetzlich auch Normalform-URLs
   #   der Form "/index.php?article_id=ID&clang=CID..." beruecksichtigt.
   #
   $arr=explode("?",substr($_SERVER["REQUEST_URI"],1));
   if($arr[0]=="index.php" and
      (substr($arr[1],0,11)=="article_id=" or strpos($arr[1],"article_id=")>0)):
     # --- Normalform-URL
     $brr=explode("&",$arr[1]);
     for($i=0;$i<count($brr);$i=$i+1):
        $crr=explode("=",$brr[$i]);
        if($crr[0]=="article_id") $art_id=$crr[1];
        if($crr[0]=="clang")      $clang =$crr[1];
        endfor;
     return rex_article::get($art_id,$clang_id);
     else:
     # --- Wunsch-URL
     return self::get_article($arr[0]);
     endif;
   }
function get_article($requested_url) {
   #   Rueckgabe des Artikel-Objekts zum aufgerufenen URL.
   #   Falls der Artikel offline ist oder nicht gefunden wird,
   #   wird stattdessen der Notfound-Artikel zurueck gegeben.
   #   $requested_url     aufgerufener relativer URL
   #
   $brr=explode("-",$requested_url);
   $art_id=intval($brr[0]);
   foreach(rex_clang::getAll() as $key=>$lang):
          $id=$lang->getId();
          if(rex_clang::get($id)->getCode()==$brr[1]):
            $clang_id=$id;
            break;
            endif;
          endforeach;
   $article=rex_article::get($art_id,$clang_id);
   if($article==NULL) $article=rex_article::getNotfoundArticle();
   if($article->getValue("status")<=0) $article=rex_article::getNotfoundArticle();
   return $article;
   }
}
